=== debian/control ===
Source: bsterminal
Section: net
Priority: optional
Maintainer: BlockSettle AB <hello@blocksettle.com>
Build-Depends: debhelper (>= 9),
               cmake,
               pkg-config,
               python,
               python-requests,
               libmysqlclient-dev,
               autoconf,
               libtool,
               yasm,
               nasm,
               g++,
               default-libmysqlclient-dev,
               dh-exec,
               dpkg-dev (>= 1.17.14),
               firebird-dev [kfreebsd-any linux-any],
               freetds-dev,
               gdb,
               libasound2-dev [linux-any],
               libatspi2.0-dev,
               libcups2-dev,
               libdbus-1-dev,
               libdouble-conversion-dev,
               libfontconfig1-dev,
               libfreetype6-dev,
               libgbm-dev [linux-any kfreebsd-any],
               libgl1-mesa-dev | libgl-dev,
               libgles2-mesa-dev | libgles2-dev,
               libglib2.0-dev,
               libglu1-mesa-dev | libglu-dev,
               libgtk-3-dev,
               libharfbuzz-dev,
               libicu-dev,
               libinput-dev [linux-any],
               libjpeg-dev,
               libmtdev-dev [linux-any],
               libpng-dev,
               libpq-dev,
               libproxy-dev,
               libpulse-dev,
               libsqlite3-dev,
               libssl-dev,
               libudev-dev [linux-any],
               libx11-dev,
               libx11-xcb-dev,
               libxcb-icccm4-dev,
               libxcb-image0-dev,
               libxcb-keysyms1-dev,
               libxcb-randr0-dev,
               libxcb-render-util0-dev,
               libxcb-render0-dev,
               libxcb-shape0-dev,
               libxcb-shm0-dev,
               libxcb-sync-dev,
               libxcb-xfixes0-dev,
               libxcb-xinerama0-dev,
               libxcb-xkb-dev,
               libxcb1-dev,
               libxext-dev,
               libxi-dev,
               libxkbcommon-dev,
               libxkbcommon-x11-dev,
               libxrender-dev,
               pkg-kde-tools (>= 0.15.17~),
               publicsuffix,
               unixodbc-dev,
               zlib1g-dev
Standards-Version: 4.1.2
Homepage: http://blocksettle.com

Package: bsterminal
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, desktop-file-utils, xdg-utils
Description: BlockSettle bitcoin terminal and wallet manager
 This application is as terminal for BlockSettle's real-time
 settlement network, but can also act as a comprehensive Bitcoin
 wallet software.
