=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE := 1
export DEB_BUILD_OPTIONS := parallel=$(shell nproc) $(DEB_BUILD_OPTIONS)

%:
	dh $@ --build-system=cmake --parallel --without autoreconf

override_dh_auto_configure:
	BS_GIT_REVISION="1702d72825958d125c935f6f48863469708447b2" DEV_3RD_ROOT=`pwd`/deps python ./generate.py release
	BS_GIT_REVISION="1702d72825958d125c935f6f48863469708447b2" DEV_3RD_ROOT=`pwd`/deps dh_auto_configure -- -DPRODUCTION_BUILD=1 -Wno-dev -DCMAKE_BUILD_TYPE=Release

override_dh_auto_install:
	dh_auto_install
	mkdir -p $(CURDIR)/debian/bsterminal/usr/bin/
	cp $(CURDIR)/build_terminal/Release/bin/blocksettle $(CURDIR)/debian/bsterminal/usr/bin/
	cp $(CURDIR)/build_terminal/Release/bin/blocksettle_signer $(CURDIR)/debian/bsterminal/usr/bin/
	cp $(CURDIR)/Deploy/Ubuntu/usr -r $(CURDIR)/debian/bsterminal/

override_dh_auto_clean:
	dh_auto_clean
	rm -rf "$(CURDIR)/generated_proto"
	rm -rf "$(CURDIR)/build_terminal"
	rm -rf "$(CURDIR)/external/build_"*
